--
-- Project:  LuaIDL
-- Version:  0.5.1b
-- Author:   Ricardo Calheiros <rcosme@tecgraf.puc-rio.br>
-- Last modification: 23/09/05 21:45
-- Filename: init.lua
-- 

local unpack  = unpack
local assert  = assert
local pcall   = pcall
local require = require

local io = require "io"
local os = require "os"

module( 'luaidl' )

local pre = require 'luaidl.pre'
local sin = require 'luaidl.sin'

function parse( stridl )
  local status, tab_output = pcall( sin.parse, stridl )
  if status then
    return unpack( tab_output )
  else
    return nil, tab_output
  end --if
end

function parsefile( idlfilename )
  local fh = assert( io.open( idlfilename ) )
  local stridl = fh:read( '*a' )
  stridl = pre.run( stridl, idlfilename )
  fh:close()
  return parse( stridl )
end

-- CPP SUPPORT BEGIN
--[[
function parsefile( idlfilename, prefilename )
  if not prefilename then
    prefilename = idlfilename..'.pre.idl'
  end --if
  pre.idlpp( idlfilename, prefilename )
  local fh = assert( io.open( prefilename ) )
  local stridl = fh:read( '*a' )
  fh:close()
  os.remove( prefilename )
  return parse( stridl )
end
]]
-- CPP SUPPORT END
