local type   = type
local unpack = unpack

local loop = require "loop"
local oo   = require "loop.base"

module("luaunit.framework.Constructable",
	loop.define(oo.class()),
	loop.seeapi(oo) )

function __init(class, ...)
	local object = rawnew(class)
	if type(object.constructor) == "function" then
		object:constructor(unpack(arg))
	end
	return object
end
