local require = require
local rawset  = rawset

local loop = require "loop"
local oo   = require "loop.scoped"

module("luaunit.framework.TestFailure",
	loop.define(oo.class({}, require "luaunit.framework.Constructable")),
	loop.seeapi(oo) )

local FailureException = require "luaunit.framework.FailureException"

protected = {}

function constructor(self, test, error)
	rawset(protected(self), "fFailedTest", test)
	rawset(protected(self), "fErrorMessage", error)
end

function public:errorMessage()
	return self.fErrorMessage
end

function public:failedTest()
	return self.fFailedTest
end

function public:isFailure()
	return instanceof(self.fErrorMessage, FailureException)
end
