require "luaunit.runner.BasicRunner"
require "luaunit.tests.DefaultTestCase"

-------------------------------------------------------------------------------

local tests = { fTestsInSuite = 3 }

function tests:setUp()
	self.runner = luaunit.runner.BasicRunner()
	self.test = luaunit.tests.DefaultTestCase()
	self.suite = luaunit.framework.TestSuite("Teste Suite")
	print("-----------------------------------------------------------")
end

function tests:tearDown()
	print("-----------------------------------------------------------")
	self.runner = nil
	self.test = nil
	self.suite = nil
end

function tests:TestCorrectCaseRun(test_name)
	self.test.name = "testOK"
	self.runner:doRun(self.test)
end

function tests:TestCorrectSuiteRun(test_name)
	for i = 1, self.fTestsInSuite do
		self.suite:addTest(luaunit.tests.DefaultTestCase("testOK"))
	end
	self.runner:doRun(self.suite)
end

function tests:TestErrorCaseRun(test_name)
	self.test.name = "testError"
	self.runner:doRun(self.test)
end

function tests:TestErrorSuiteRun(test_name)
	for i = 1, self.fTestsInSuite do
		self.suite:addTest(luaunit.tests.DefaultTestCase("testError"))
	end
	self.runner:doRun(self.suite)
end

function tests:TestFailedCaseRun(test_name)
	self.test.name = "testFailure"
	self.runner:doRun(self.test)
end

function tests:TestFailedSuiteRun(test_name)
	for i = 1, self.fTestsInSuite do
		self.suite:addTest(luaunit.tests.DefaultTestCase("testFailure"))
	end
	self.runner:doRun(self.suite)
end

return tests