require "luaunit.framework.TestFailure"

-------------------------------------------------------------------------------

local tests = {}

function tests:setUp()
	self.test = { name = "test" }
	self.errorMessage = "message"
	local success
	success, self.failureMessage = pcall(luaunit.framework.Assert.fail, luaunit.framework.Assert)
	self.testError = luaunit.framework.TestFailure(self.test, self.errorMessage)
	self.testFailure = luaunit.framework.TestFailure(self.test, self.failureMessage)
end

function tests:tearDown()
	self.test = nil
	self.errorMessage = nil
	self.failureMessage = nil
	self.testError = nil
	self.testFailure = nil
end

function tests:TestError(test_name)
	assert(self.testError:failedTest() == self.test, "'failedTest' is not the expected test at '" .. test_name .. "'")
	assert(self.testError:errorMessage() == self.errorMessage, "'errorMessage' is not the expected message at '" .. test_name .. "'")
	assert(not self.testError:isFailure(), "'isFailure' failed for a test error at '" .. test_name .. "'")
end

function tests:TestFailure(test_name)
	assert(self.testFailure:failedTest() == self.test, "'failedTest' is not the expected test at '" .. test_name .. "'")
	assert(self.testFailure:errorMessage() == self.failureMessage, "'errorMessage' is not the expected message at '" .. test_name .. "'")
	assert(self.testFailure:isFailure(), "'isFailure' failed for a test failure at '" .. test_name .. "'")
end

return tests
