if
	not arg or
	not arg[1] or
	not arg[2]
then
	print [[
Usage:
	lua oil/testall.lua <Linux|Windows> <Config File Name>
]]
end

require "scheduler"
require "oil"

pcall = scheduler.pcall

scheduler.new(function()
	local Pause = false
	
	local TestSuite      = require "luaunit.framework.TestSuite"
	local BasicRunner    = require "luaunit.runner.BasicRunner"
	local MonoTest       = require "oil.tests.bases.MonoTest"
	local ConcTest       = require "oil.tests.bases.ConcTest"
	local LuaIDLLoader   = require "oil.tests.loader.LuaIDL"
	local RemoteIRLoader = require "oil.tests.loader.RemoteIR"
	local NaiveSystem    = require("oil.tests.system.naive."..arg[1])
	
	local cases = {
		require "oil.tests.cases.NamingService",
		require "oil.tests.cases.SelfIsA",
		require "oil.tests.cases.Callback",
		require "oil.tests.cases.MonoHello",
		require "oil.tests.cases.ConcHello",
		require "oil.tests.cases.Marshal",
	}
	
	local runner   = BasicRunner()
	local naivesys = NaiveSystem(arg[2])
	local luaidl   = LuaIDLLoader()
	local remoteIR = RemoteIRLoader{ system = naivesys }
	
	local suite = TestSuite()
	
	for _, case in ipairs(cases) do
		if not case.NoMonothread then
			suite:addTest(MonoTest(case, naivesys, luaidl)  , Pause)
			suite:addTest(MonoTest(case, naivesys, remoteIR), Pause)
		end
		if not case.NoConcurrency then
			suite:addTest(ConcTest(case, naivesys, luaidl)  , Pause)
			suite:addTest(ConcTest(case, naivesys, remoteIR), Pause)
		end
	end
	
	--for _, case in ipairs(cases) do
	--	if not case.NoMonothread then
	--		runner:doRun(MonoTest(case, naivesys, luaidl)  , Pause)
	--		runner:doRun(MonoTest(case, naivesys, remoteIR), Pause)
	--	end
	--	if not case.NoConcurrency then
	--		runner:doRun(ConcTest(case, naivesys, luaidl)  , Pause)
	--		runner:doRun(ConcTest(case, naivesys, remoteIR), Pause)
	--	end
	--end
	
	runner:doRun(suite)
	
	os.exit()
end)

scheduler.new(oil.run)
scheduler.run()
