local ipairs   = ipairs
local loop     = require "loop"
local oo       = require "loop.scoped"
local TestCase = require "luaunit.framework.TestCase"

module("oil.tests.bases.BaseTest",
	loop.define(oo.class({}, TestCase)),
	loop.seeapi(oo) )

function constructor(self, case, system, loader)
	self.case = case
	self.system = system
	self.loader = loader
	return TestCase.constructor(self, case._NAME)
end

function setUp(self)
	if self.case.Services then
		for _, service in ipairs(self.case.Services) do
			self.system:getService(service)
		end
	end
end
