--
-- Case test by Helcio Mello
--

module("oil.tests.cases.Callback")

IDL = [[
	module Callback {
		interface Value {
			attribute long val;
		};
		interface Server {
			long examine(in Value val);
		};
	};
]]

Servers = {
[[
	local server = {}
	function server:examine(value)
		return value:_get_val()
	end
	
	OiLTestRegister("CallbackServer", oil.newobject(server, "Callback::Server"))
]],
[[
	math.randomseed(socket.gettime())
	local value = { val = math.random(255) }

	OiLTestRegister("CallbackValue", oil.newobject(value, "Callback::Value"))
]],
}

Client = [[
	local server = oil.narrow(OiLTestLookUp("CallbackServer"), "Callback::Server")
	local value = oil.narrow(OiLTestLookUp("CallbackValue"), "Callback::Value")
	Assert:assertEquals(server:examine(value), value:_get_val())
]]
