module("oil.tests.cases.ConcHello")

IDL = [[
	interface Hello {
		attribute boolean quiet;
		readonly attribute long count;
		string say_hello_to(in string name);
	};
]]

Servers = {
[[
	local hello = { count = 0 }
	function hello:say_hello_to(name)
		self.count = self.count + 1
		local msg = "Hello "..name.."! ("..self.count.." times)"
		if not self.quiet then print(msg) end
		return msg
	end
	
	OiLTestRegister("Hello", oil.newobject(hello, "Hello"))
]],
}

Client = [[
	local hello = oil.narrow(OiLTestLookUp("Hello"), "Hello")
	
	hello:_set_quiet(true)
	for i = 1, 3 do
		Assert:assertEquals(
			hello:say_hello_to("world"),
			"Hello world! ("..i.." times)"
		)
	end
	Assert:assertEquals(hello:_get_count(), 3)
]]
