--
-- Case test by Helcio Mello
--

module("oil.tests.cases.SelfIsA")

NoMonothread = true

IDL = [[
	module SelfIsA {
		interface TestObject {
			boolean self_is_a(in string repID);
		};
	};
]]

Servers = {
[[
	local impl = {}
	local object = oil.newobject(impl, "SelfIsA::TestObject")
	local proxy = oil.newproxy(object:_ior())

	function impl:self_is_a(repid)
		return proxy:_is_a(repid)
	end
	
	OiLTestRegister("SelfIsA", object)
]],
}

Client = [[
	local object = oil.narrow(OiLTestLookUp("SelfIsA"), "SelfIsA::TestObject")
	Assert:assertTrue(object:self_is_a("IDL:SelfIsA/TestObject:1.0"))
]]
