local print  = print
local assert = assert
local ipairs = ipairs

local io   = require "io"
local os   = require "os"
local loop = require "loop"
local oo   = require "loop.base"
local oil  = require "oil"

module("oil.tests.loader.RemoteIR",
	loop.define(oo.class()),
	loop.seeapi(oo) )

function __init(class, self)
	self = rawnew(class, self)
	self.ir_ior = oil.ior.encode(self.system:getService("InterfaceRepository"))
	return self
end

function loadfile(self, idlfile)
	os.execute(self.system:getCommand("IRLoadIDL", {
		ir_ior = self.ir_ior,
		idl_file = idlfile,
	}))
end

function getLoading(self, case)
	if case.IDLFiles then
		for _, file in ipairs(case.IDLFiles) do
			self:loadfile("luaidl/db/"..file)
		end
	end
	if case.IDL then
		local file = assert(io.open("temp/LoadIR.idl", "w"))
		file:write(case.IDL)
		file:close()
		self:loadfile("temp/LoadIR.idl")
		os.remove("temp/LoadIR.idl")
	end
	return [[
		oil.setIR(oil.narrow(
			OiLTestLookUp("services/InterfaceRepository"),
			"IDL:omg.org/CORBA/Repository:1.0"
		))
	]]
end
