local assert     = assert
local loadstring = loadstring

local io     = require "io"
local string = require "string"
local loop   = require "loop"
local oo     = require "loop.base"

module("oil.tests.system.SystemBase",
	loop.define(oo.class()),
	loop.seeapi(oo) )

function __init(class, configfile)
	local self = { Services = {} }
	local file = assert(io.open(configfile))
	local code = "return { "..file:read("*a").." }"
	file:close()
	self.Commands = assert(loadstring(code, "Service Commands Config"))()
	return rawnew(class, self)
end

function getCommand(self, service, params)
	local command = self.Commands[service]
	return (string.gsub(command, "%%([%w_]+)", function(key)
		return params[key]
	end))
end
