------------------------------------------------------------------------------
-- Project: Serialization of Lua Values                                     --
-- Release: 2.0 alpha                                                       --
-- Title  : Buffered Stream of Lua Values                                   --
-- Author : Renato Maia <maia@inf.puc-rio.br>                               --
-- Date   : 12/28/2004 12:00                                                --
------------------------------------------------------------------------------

local assert  = assert
local type    = type
local unpack  = unpack
local require = require

local loop          = require "loop"
local oo            = require "loop.simple"
local serialization = require "serialization"

module("serialization.BufferStream",
	loop.define(oo.class()),
	loop.seeapi(oo) )

local OrderedSet = require "collection.OrderedSet"

function __init(class, object)
	if object
		then assert(type(object.buffer) == "table", "no buffer defined")
		else object = { buffer = OrderedSet() }
	end
	return rawnew(class, object)
end

function put(self, ...)
	self.buffer:enqueue(serialization.serialize(unpack(arg)))
end

function get(self)
	return serialization.load(self.buffer:dequeue())
end