------------------------------------------------------------------------------
-- Project: Serialization of Lua Values                                     --
-- Release: 2.0 alpha                                                       --
-- Title  : Stream of Lua Values for Sockets                                --
-- Author : Renato Maia <maia@inf.puc-rio.br>                               --
-- Date   : 12/28/2004 12:00                                                --
------------------------------------------------------------------------------

local assert = assert
local unpack = unpack

local loop          = require "loop"
local oo            = require "loop.simple"
local serialization = require "serialization"

module("serialization.SocketStream",
	loop.define(oo.class()),
	loop.seeapi(oo) )

function __init(class, object)
	assert(object.socket, "invalid socket")
	return rawnew(class, object)
end

function put(self, ...)
	return self.socket:send(serialization.serialize(unpack(arg)).."\0")
end

function get(self)
	local data, errmsg = self.socket:receive("\0")
	if data
		then return serialization.load(data)
		else return data, errmsg
	end
end

function close(self)
	return self.socket:close()
end